#!/usr/bin/env python2.1


__version__ = '$Id: partition.py,v 1.2 2002/02/25 18:49:07 andreas Exp $'

import os,sys,re
import weblog.common,getopt
import time
from random import randrange
from common.Request import Request

START = time.mktime((2001,11,12,9+4,0,0,0,0,0))
END   = time.mktime((2001,11,12,10+4,0,0,0,0,0))

requests = []


def reqsort(a,b):
    return cmp(a.timestamp,b.timestamp)


def parseFiles(files):

    for f in files:
        print f

        vhost = os.path.basename(f).replace('.com_hostname_access','') \
		        + '.cbs.zope.com'

        print vhost
        log = weblog.common.Parser(open(f))

        read = 0
        while log.getlogent():
            read+=1

            if read % 10000 ==0:
                print read

            if log.utime<START or log.utime>END: continue

            else:

                if randrange(0,5)<2:
                    throttle = 8.0*log.bytes/56000
                else:
                    throttle = 0.0

                req = Request(  
                            timestamp=log.utime,
                            method=log.method,
                            path = log.url,
                            throttle = throttle,
                            headers={'host' : vhost},
                            )

                requests.append( req )


    # Now sort the requests by date
    requests.sort(reqsort)

    # and write them to disk
    ts = requests[0].timestamp

    fp = open('out.dat','w')
    for r in requests:
        r.timestamp = r.timestamp - ts
        fp.write(str(r) +'\n')

    fp.close() 



def usage():
    print '%s files ...' %\
        os.path.basename(sys.argv[0])


if __name__=='__main__':

    opts,args = getopt.getopt(sys.argv[1:],'h', \
		['help'])

    for o,v in opts:
        if o in ['--help','-h']:        usage(); sys.exit(1) 

    parseFiles(args)
    os._exit(0)

